-- Default settings
defaultSettings = {
    sell = true;
	give = true;
	valar = true;
	buy = true;
	search = true;
	exchange = true;
};
settings = {};
DeepTableCopy(defaultSettings, settings);

optionsPanel = Turbine.UI.Control();

-- Function for drawing the options panel
function UpdateOptionsPanel()
    local prevContext = L:SetContext("/OptionsPanel");
    local font = Turbine.UI.Lotro.Font.Verdana12;
    local left, top, width = 10, 10, 300;
    local columnWidth = math.floor(width / 2);
    
    if (not optionsPanel.sell) then
		--Sell
        optionsPanel.sell = Turbine.UI.Lotro.CheckBox();
        optionsPanel.sell:SetParent(optionsPanel);
        optionsPanel.sell:SetSize(width, 16);
        optionsPanel.sell:SetPosition(left, top);
        optionsPanel.sell:SetFont(font);
        optionsPanel.sell:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);        
        optionsPanel.sell:SetText("VK/ vk/ Vk/ vK/ Verkaufe/ verkaufe");
        optionsPanel.sell.CheckedChanged = function(box)
            settings.sell = box:IsChecked();
            DoCallbacks(optionsPanel, "SettingsChanged");
        end
	end
	
		local function add_horizontal_line(top)
            top = top + 24
            local line = Turbine.UI.Control();
            line:SetParent(optionsPanel);
            line:SetPosition(0, top);
            line:SetSize(width + (left * 2), 1);
            line:SetBackColor(Turbine.UI.Color(41/255, 48/255, 72/255));
            return top + 8;
        end
	
		top = add_horizontal_line(top);
	if (not optionsPanel.give) then
		--Give
		optionsPanel.give = Turbine.UI.Lotro.CheckBox();
        optionsPanel.give:SetParent(optionsPanel);
        optionsPanel.give:SetSize(width, 16);
        optionsPanel.give:SetPosition(left, top);
        optionsPanel.give:SetFont(font);
        optionsPanel.give:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);        
        optionsPanel.give:SetText("VS/ vs/ Vs/ vS/ Verschenke/ verschenke");
        optionsPanel.give.CheckedChanged = function(box)
            settings.give = box:IsChecked();
            DoCallbacks(optionsPanel, "SettingsChanged");
		end
	end

		top = add_horizontal_line(top);	
	if (not optionsPanel.valar) then
		--Valar
		optionsPanel.valar = Turbine.UI.Lotro.CheckBox();
        optionsPanel.valar:SetParent(optionsPanel);
        optionsPanel.valar:SetSize(width, 16);
        optionsPanel.valar:SetPosition(left, top);
        optionsPanel.valar:SetFont(font);
        optionsPanel.valar:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);        
        optionsPanel.valar:SetText("Geschenk der Valar/ Segen der Valar");
        optionsPanel.valar.CheckedChanged = function(box)
            settings.valar = box:IsChecked();
            DoCallbacks(optionsPanel, "SettingsChanged");
		end
	end

		top = add_horizontal_line(top);	
	if (not optionsPanel.buy) then
		-- Buy
		optionsPanel.buy = Turbine.UI.Lotro.CheckBox();
        optionsPanel.buy:SetParent(optionsPanel);
        optionsPanel.buy:SetSize(width, 16);
        optionsPanel.buy:SetPosition(left, top);
        optionsPanel.buy:SetFont(font);
        optionsPanel.buy:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);        
        optionsPanel.buy:SetText("Kaufe/ kaufe");
        optionsPanel.buy.CheckedChanged = function(box)
            settings.buy = box:IsChecked();
            DoCallbacks(optionsPanel, "SettingsChanged");
		end
	end

		top = add_horizontal_line(top);	
	if (not optionsPanel.search) then
		-- Search
		optionsPanel.search = Turbine.UI.Lotro.CheckBox();
        optionsPanel.search:SetParent(optionsPanel);
        optionsPanel.search:SetSize(width, 16);
        optionsPanel.search:SetPosition(left, top);
        optionsPanel.search:SetFont(font);
        optionsPanel.search:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);        
        optionsPanel.search:SetText("Suche/ suche");
        optionsPanel.search.CheckedChanged = function(box)
            settings.search = box:IsChecked();
            DoCallbacks(optionsPanel, "SettingsChanged");
		end
	end

		top = add_horizontal_line(top);
	if (not optionsPanel.exchange) then	
		-- Exchange
		optionsPanel.exchange = Turbine.UI.Lotro.CheckBox();
        optionsPanel.exchange:SetParent(optionsPanel);
        optionsPanel.exchange:SetSize(width, 16);
        optionsPanel.exchange:SetPosition(left, top);
        optionsPanel.exchange:SetFont(font);
        optionsPanel.exchange:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);        
        optionsPanel.exchange:SetText("Tausche/ tausche");
        optionsPanel.exchange.CheckedChanged = function(box)
            settings.exchange = box:IsChecked();
            DoCallbacks(optionsPanel, "SettingsChanged");
		end	
	end
	
        top = add_horizontal_line(top);
        local resetButton = Turbine.UI.Lotro.Button();
        resetButton:SetParent(optionsPanel);
        resetButton:SetText("Reset to defaults");
        resetButton:SetWidth(175);
        resetButton:SetPosition(left, top);
        resetButton.Click = function()
            DeepTableCopy(defaultSettings, settings);
            UpdateOptionsPanel();
            DoCallbacks(optionsPanel, "SettingsChanged");
        end;
        top = top + resetButton:GetHeight();
        
        optionsPanel:SetSize(width, top);
    
    optionsPanel.sell:SetChecked(settings.sell);
	optionsPanel.give:SetChecked(settings.give);
	optionsPanel.valar:SetChecked(settings.valar);	    
    optionsPanel.buy:SetChecked(settings.buy);
	optionsPanel.search:SetChecked(settings.search);
	optionsPanel.exchange:SetChecked(settings.exchange);

    L:SetContext(prevContext);
end

function SaveSettings()
Turbine.Shell.WriteLine("Saving...");
    -- Workaround for Turbine localization bug
    local saveData = ExportTable(settings);    
    Turbine.PluginData.Save(Turbine.DataScope.Account, "ChatFilter", saveData, function()
--Turbine.Shell.WriteLine("Save complete.");
    end);
end

function LoadSettings()
    Turbine.PluginData.Load(Turbine.DataScope.Account, "ChatFilter", function(loadedData)
--Turbine.Shell.WriteLine("Loading...");
        if (loadedData) then
            -- Workaround for Turbine localization bug
            loadedData = ImportTable(loadedData);
            DeepTableCopy(loadedData, settings);
            --settings.color = Turbine.UI.Color(settings.color.A, settings.color.R, settings.color.G, settings.color.B);
            UpdateOptionsPanel();
            DoCallbacks(optionsPanel, "SettingsChanged");
--Turbine.Shell.WriteLine("Load complete.");
        end
    end);
end

-- Display the default settings
UpdateOptionsPanel();

-- Create the "options" tab in the plugin manager.
plugin.GetOptionsPanel = function()
    return optionsPanel;
end

Turbine.Plugin.Load = LoadSettings;
Turbine.Plugin.Unload = SaveSettings;
